#!/bin/sh

#GPU=GTXTitanBlack
#GPU=TeslaK20c
#GPU=GTX580
#GPU=GTX750Ti

GPU=`/bin/sh ../tuning/get_dev_info.sh | awk '/DEVICE/{ gsub(/^[A-Za-z0-9]*-/,"",$2); gsub(/-/,""); print $2; }'`

EXEC=''

$EXEC ./test2-sgemv-n | tee log-ASPEN.K2-1.4-SGEMVN-$GPU
$EXEC ./test2-sgemv-t | tee log-ASPEN.K2-1.4-SGEMVT-$GPU
$EXEC ./test2-ssymv-u | tee log-ASPEN.K2-1.4-SSYMVU-$GPU

$EXEC ./test2-dgemv-n | tee log-ASPEN.K2-1.4-DGEMVN-$GPU
$EXEC ./test2-dgemv-t | tee log-ASPEN.K2-1.4-DGEMVT-$GPU
$EXEC ./test2-dsymv-u | tee log-ASPEN.K2-1.4-DSYMVU-$GPU

$EXEC ./cuda-sgemv-n | tee log-CUDA-6.5-SGEMVN-$GPU
$EXEC ./cuda-sgemv-t | tee log-CUDA-6.5-SGEMVT-$GPU
$EXEC ./cuda-ssymv-u | tee log-CUDA-6.5-SSYMVU-$GPU

$EXEC ./cuda-dgemv-n | tee log-CUDA-6.5-DGEMVN-$GPU
$EXEC ./cuda-dgemv-t | tee log-CUDA-6.5-DGEMVT-$GPU
$EXEC ./cuda-dsymv-u | tee log-CUDA-6.5-DSYMVU-$GPU

$EXEC ./magma-sgemv-n | tee log-MAGMA-1.5.0-SGEMVN-$GPU
$EXEC ./magma-sgemv-t | tee log-MAGMA-1.5.0-SGEMVT-$GPU
$EXEC ./magma-ssymv-u | tee log-MAGMA-1.5.0-SSYMVU-$GPU

$EXEC ./magma-dgemv-n | tee log-MAGMA-1.5.0-DGEMVN-$GPU
$EXEC ./magma-dgemv-t | tee log-MAGMA-1.5.0-DGEMVT-$GPU
$EXEC ./magma-dsymv-u | tee log-MAGMA-1.5.0-DSYMVU-$GPU

$EXEC ./kblas-sgemv-n | tee log-KBLAS-1.0-SGEMVN-$GPU
$EXEC ./kblas-sgemv-t | tee log-KBLAS-1.0-SGEMVT-$GPU
$EXEC ./kblas-ssymv-u | tee log-KBLAS-1.0-SSYMVU-$GPU

$EXEC ./kblas-dgemv-n | tee log-KBLAS-1.0-DGEMVN-$GPU
$EXEC ./kblas-dgemv-t | tee log-KBLAS-1.0-DGEMVT-$GPU
$EXEC ./kblas-dsymv-u | tee log-KBLAS-1.0-DSYMVU-$GPU


