#define	GPUs \
		TESLA,FERMI,KEPLER,KEPLER2,MAXWELL

#define	DEF_prototype_by_GPU( func, ... ) \
		__EXPAND_proto__( func, GPUs )

#define __EXPAND_proto__( func, ... ) \
		__EXPAND_proto( func, __VA_ARGS__)

#define	__NAME__( a, b ) \
		API( a##b )

#define	_prototype( func, GPU ) \
		extern "C" __host__ void \
		__NAME__( func, GPU ) func##_##args

#define	__EXPAND_proto( func, GPU1, GPU2, GPU3, GPU4, GPU5, ... ) \
		_prototype( func, ); \
		_prototype( func, _##GPU1 ); \
		_prototype( func, _##GPU2 ); \
		_prototype( func, _##GPU3 ); \
		_prototype( func, _##GPU4 ); \
		_prototype( func, _##GPU5 )




   extern "C" __host__ void
   API(DZERO) ( double * dwork, int ldwork );


#define	DGEMV_n_args \
	( int blk, \
		const double alpha, const double beta, \
		const double * a, const double * x, \
		double * y, \
		const int lda, \
		const int n1, const int n2 )

DEF_prototype_by_GPU( DGEMV_n, GPUs );

#define	DGEMV_t_args \
	( int blk, \
		const double alpha, const double beta, \
		const double * a, const double * x, \
		double * y, \
		const int lda, \
		const int n1, const int n2 )

DEF_prototype_by_GPU( DGEMV_t, GPUs );

   extern "C"void
   API(DSYMVu) ( const int blk,
        const int n,
        const double * A, const int lda,
        const double * x, double * y,
        const double alpha, const double beta );

#define DSYMVu_LARGE_args \
	( const int blk, \
		const int n, \
	        const double * a, const int lda, \
		const double * x, double * y, \
		const double alpha, const double beta )

DEF_prototype_by_GPU( DSYMVu_LARGE, GPUs );

   extern "C" __host__ void
   API(DSYMVu_lu) ( const int n,
	const double * a, const int lda,
        const double * x, double * y,
	const double alpha, const double beta );

   extern "C" __host__ void
   API(DTRMV_n_upper_for_DSYMV) (
        const double alpha, const double beta,
	const double * a, const double * x,
	double * y,
	const int lda,
	const int n );

   extern "C" __host__ void
   API(DTRMV_t_upper_for_DSYMV) (
        const double alpha, const double beta,
	const double * a, const double * x,
	double * y,
	const int lda,
	const int n );




   extern "C" __host__ void
   API(SZERO) ( float * dwork, int ldwork );

   extern "C" __host__ void
   API(SGEMV_n) ( int blk,
        const float alpha, const float beta,
        const float * a, const float * x,
        float * y,
        const int lda,
        const int n1, const int n2 );

#define	SGEMV_n_args \
	( int blk, \
		const float alpha, const float beta, \
		const float * a, const float * x, \
		float * y, \
		const int lda, \
		const int n1, const int n2 )

DEF_prototype_by_GPU( SGEMV_n, GPUs );

#define	SGEMV_t_args \
	( int blk, \
		const float alpha, const float beta, \
		const float * a, const float * x, \
		float * y, \
		const int lda, \
		const int n1, const int n2 )

DEF_prototype_by_GPU( SGEMV_t, GPUs );

   extern "C" __host__ void
   API(SSYMVu) ( const int blk,
        const int n,
        const float * A, const int lda,
        const float * x, float * y,
        const float alpha, const float beta );

#define SSYMVu_LARGE_args \
	( const int blk, \
		const int n, \
	        const float * a, const int lda, \
		const float * x, float * y, \
		const float alpha, const float beta )

DEF_prototype_by_GPU( SSYMVu_LARGE, GPUs );

   extern "C" __host__ void
   API(SSYMVu_lu) ( const int n,
	const float * a, const int lda,
        const float * x, float * y,
	const float alpha, const float beta );

   extern "C" __host__ void
   API(STRMV_n_upper_for_SSYMV) (
        const float alpha, const float beta,
	const float * a, const float * x,
	float * y,
	const int lda,
	const int n);

   extern "C" __host__ void
   API(STRMV_t_upper_for_SSYMV) (
        const float alpha, const float beta,
	const float * a, const float * x,
	float * y,
	const int lda,
	const int n);

