#include "float.h"
#include "aspen_devel.h"

#include "../tuning/CURRENT_GPU"


extern "C" void
API(SGEMV_n) ( int blk,
		const scalar_t alpha, const scalar_t beta,
		const scalar_t * a, const scalar_t * x,
		scalar_t * y,
                const int lda,
		const int n1, const int n2 )
{

   if ( n1 <= 0 || n2 <= 0 ) return;
   if ( alpha == CONST(0) && beta == CONST(1) ) return;

   int Ver = API(get_device_CC) ( );

   switch ( Ver ) {
#if CURRENT_GPU==Tesla
   case Tesla:
	API(SGEMV_n_TESLA) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
#endif
#if CURRENT_GPU==Fermi
   case Fermi:
	API(SGEMV_n_FERMI) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
#endif
#if CURRENT_GPU==Kepler
   case Kepler:
	API(SGEMV_n_KEPLER) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
#endif
#if CURRENT_GPU==Kepler2
   case Kepler2:
	API(SGEMV_n_KEPLER2) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
#endif
#if CURRENT_GPU==Maxwell
   case Maxwell:
	API(SGEMV_n_MAXWELL) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
#endif
   default:
	break;
   }

}

