#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
Wed Sep 10 10:55:31 JST 2014
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

if ( n >= 1 && n < 540 ) {
	BLK = 12;
} else 
if ( n >= 540 && n < 780 ) {
	BLK = 13;
} else 
if ( n >= 780 && n < 926 ) {
	BLK = 11;
} else 
if ( n >= 926 && n < 1200 ) {
	BLK = 7;
} else 
if ( n >= 1200 && n < 1440 ) {
	BLK = 15;
} else 
if ( n >= 1440 && n < 1560 ) {
	BLK = 13;
} else 
if ( n >= 1560 && n < 1598 ) {
	BLK = 14;
} else 
if ( n >= 1598 && n < 2022 ) {
	BLK = 16;
} else 
if ( n >= 2022 && n < 2700 ) {
	BLK = 8;
} else 
if ( n >= 2700 && n < 2722 ) {
	BLK = 14;
} else 
if ( n >= 2722 && n < 2880 ) {
	BLK = 15;
} else 
if ( n >= 2880 && n < 3025 ) {
	BLK = 14;
} else 
if ( n >= 3025 && n < 3120 ) {
	BLK = 13;
} else 
if ( n >= 3120 && n < 3157 ) {
	BLK = 14;
} else 
if ( n >= 3157 && n < 3339 ) {
	BLK = 4;
} else 
if ( n >= 3339 && n < 3600 ) {
	BLK = 7;
} else 
if ( n >= 3600 && n < 4265 ) {
	BLK = 4;
} else 
if ( n >= 4265 && n < 4320 ) {
	BLK = 15;
} else 
if ( n >= 4320 && n < 4511 ) {
	BLK = 4;
} else 
if ( n >= 4511 && n < 4652 ) {
	BLK = 0;
} else 
if ( n >= 4652 && n < 4800 ) {
	BLK = 7;
} else 
if ( n >= 4800 && n < 7205 ) {
	BLK = 0;
} else 
	BLK = 1;

#define	_KERNEL_4 1
#define	_KERNEL_7 1
#define	_KERNEL_8 1
#define	_KERNEL_11 1
#define	_KERNEL_12 1
#define	_KERNEL_0 1
#define	_KERNEL_13 1
#define	_KERNEL_1 1
#define	_KERNEL_14 1
#define	_KERNEL_15 1
#define	_KERNEL_16 1

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if _KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 64 , 1 , 5, 1 );
		break;
#endif
#if _KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 32 , 3 , 5, 1 );
		break;
#endif
#if _KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if _KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if _KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 4 , 4, 1 );
		break;
#endif
#if _KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 64 , 1 , 6, 1 );
		break;
#endif
#if _KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 32 , 4 , 3, 1 );
		break;
#endif
#if _KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 96 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 32 , 2 , 5, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

