#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
Wed Sep 10 14:22:45 JST 2014
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

if ( n >= 1 && n < 371 ) {
	BLK = 6;
} else 
if ( n >= 371 && n < 960 ) {
	BLK = 9;
} else 
if ( n >= 960 && n < 1200 ) {
	BLK = 5;
} else 
if ( n >= 1200 && n < 1260 ) {
	BLK = 6;
} else 
if ( n >= 1260 && n < 1440 ) {
	BLK = 8;
} else 
if ( n >= 1440 && n < 1800 ) {
	BLK = 14;
} else 
if ( n >= 1800 && n < 1920 ) {
	BLK = 9;
} else 
if ( n >= 1920 && n < 2160 ) {
	BLK = 8;
} else 
if ( n >= 2160 && n < 2400 ) {
	BLK = 5;
} else 
if ( n >= 2400 && n < 2520 ) {
	BLK = 6;
} else 
if ( n >= 2520 && n < 2880 ) {
	BLK = 9;
} else 
if ( n >= 2880 && n < 3000 ) {
	BLK = 2;
} else 
if ( n >= 3000 && n < 3240 ) {
	BLK = 10;
} else 
if ( n >= 3240 && n < 3360 ) {
	BLK = 7;
} else 
if ( n >= 3360 && n < 3600 ) {
	BLK = 2;
} else 
if ( n >= 3600 && n < 3840 ) {
	BLK = 9;
} else 
if ( n >= 3840 && n < 4200 ) {
	BLK = 2;
} else 
if ( n >= 4200 && n < 4320 ) {
	BLK = 8;
} else 
if ( n >= 4320 && n < 4393 ) {
	BLK = 18;
} else 
if ( n >= 4393 && n < 4500 ) {
	BLK = 12;
} else 
if ( n >= 4500 && n < 4620 ) {
	BLK = 18;
} else 
if ( n >= 4620 && n < 4800 ) {
	BLK = 2;
} else 
if ( n >= 4800 && n < 4860 ) {
	BLK = 10;
} else 
if ( n >= 4860 && n < 5040 ) {
	BLK = 18;
} else 
if ( n >= 5040 && n < 5280 ) {
	BLK = 7;
} else 
if ( n >= 5280 && n < 5400 ) {
	BLK = 2;
} else 
if ( n >= 5400 && n < 5460 ) {
	BLK = 18;
} else 
if ( n >= 5460 && n < 5560 ) {
	BLK = 1;
} else 
if ( n >= 5560 && n < 5760 ) {
	BLK = 7;
} else 
if ( n >= 5760 && n < 5880 ) {
	BLK = 18;
} else 
if ( n >= 5880 && n < 6000 ) {
	BLK = 2;
} else 
if ( n >= 6000 && n < 6120 ) {
	BLK = 1;
} else 
if ( n >= 6120 && n < 6300 ) {
	BLK = 18;
} else 
if ( n >= 6300 && n < 6480 ) {
	BLK = 1;
} else 
if ( n >= 6480 && n < 6720 ) {
	BLK = 18;
} else 
if ( n >= 6720 && n < 6840 ) {
	BLK = 1;
} else 
if ( n >= 6840 && n < 6900 ) {
	BLK = 17;
} else 
if ( n >= 6900 && n < 7140 ) {
	BLK = 18;
} else 
if ( n >= 7140 && n < 7186 ) {
	BLK = 1;
} else 
if ( n >= 7186 && n < 7200 ) {
	BLK = 7;
} else 
if ( n >= 7200 && n < 7349 ) {
	BLK = 1;
} else 
if ( n >= 7349 && n < 7560 ) {
	BLK = 18;
} else 
if ( n >= 7560 && n < 7680 ) {
	BLK = 7;
} else 
if ( n >= 7680 && n < 7800 ) {
	BLK = 17;
} else 
if ( n >= 7800 && n < 7878 ) {
	BLK = 1;
} else 
if ( n >= 7878 && n < 7980 ) {
	BLK = 18;
} else 
if ( n >= 7980 && n < 8100 ) {
	BLK = 17;
} else 
if ( n >= 8100 && n < 8280 ) {
	BLK = 1;
} else 
if ( n >= 8280 && n < 8400 ) {
	BLK = 18;
} else 
if ( n >= 8400 && n < 8640 ) {
	BLK = 1;
} else 
if ( n >= 8640 && n < 8700 ) {
	BLK = 17;
} else 
if ( n >= 8700 && n < 8820 ) {
	BLK = 18;
} else 
if ( n >= 8820 && n < 8861 ) {
	BLK = 1;
} else 
if ( n >= 8861 && n < 9000 ) {
	BLK = 17;
} else 
if ( n >= 9000 && n < 9101 ) {
	BLK = 0;
} else 
if ( n >= 9101 && n < 9300 ) {
	BLK = 17;
} else 
if ( n >= 9300 && n < 9360 ) {
	BLK = 1;
} else 
if ( n >= 9360 && n < 9392 ) {
	BLK = 0;
} else 
if ( n >= 9392 && n < 9600 ) {
	BLK = 17;
} else 
if ( n >= 9600 && n < 9616 ) {
	BLK = 1;
} else 
if ( n >= 9616 && n < 9660 ) {
	BLK = 18;
} else 
if ( n >= 9660 && n < 9720 ) {
	BLK = 1;
} else 
if ( n >= 9720 && n < 9900 ) {
	BLK = 17;
} else 
if ( n >= 9900 && n < 10069 ) {
	BLK = 1;
} else 
if ( n >= 10069 && n < 10200 ) {
	BLK = 17;
} else 
if ( n >= 10200 && n < 10201 ) {
	BLK = 0;
} else 
if ( n >= 10201 && n < 10279 ) {
	BLK = 1;
} else 
if ( n >= 10279 && n < 10500 ) {
	BLK = 17;
} else 
if ( n >= 10500 && n < 10557 ) {
	BLK = 0;
} else 
if ( n >= 10557 && n < 10800 ) {
	BLK = 17;
} else 
if ( n >= 10800 && n < 10848 ) {
	BLK = 0;
} else 
if ( n >= 10848 && n < 11100 ) {
	BLK = 17;
} else 
if ( n >= 11100 && n < 11160 ) {
	BLK = 1;
} else 
if ( n >= 11160 && n < 11400 ) {
	BLK = 17;
} else 
if ( n >= 11400 && n < 11488 ) {
	BLK = 1;
} else 
if ( n >= 11488 && n < 11700 ) {
	BLK = 17;
} else 
if ( n >= 11700 && n < 11720 ) {
	BLK = 0;
} else 
if ( n >= 11720 && n < 12000 ) {
	BLK = 17;
} else 
if ( n >= 12000 && n < 12011 ) {
	BLK = 0;
} else 
if ( n >= 12011 && n < 12300 ) {
	BLK = 17;
} else 
if ( n >= 12300 && n < 12302 ) {
	BLK = 0;
} else 
if ( n >= 12302 && n < 12900 ) {
	BLK = 17;
} else 
if ( n >= 12900 && n < 12907 ) {
	BLK = 1;
} else 
	BLK = 17;

#define	_KERNEL_17 1
#define	_KERNEL_18 1
#define	_KERNEL_5 1
#define	_KERNEL_6 1
#define	_KERNEL_7 1
#define	_KERNEL_8 1
#define	_KERNEL_9 1
#define	_KERNEL_10 1
#define	_KERNEL_12 1
#define	_KERNEL_0 1
#define	_KERNEL_1 1
#define	_KERNEL_14 1
#define	_KERNEL_2 1

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if _KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if _KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if _KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 384 , 1 , 6, 1 );
		break;
#endif
#if _KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 128 , 1 , 5, 1 );
		break;
#endif
#if _KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if _KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 384 , 1 , 5, 1 );
		break;
#endif
#if _KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 128 , 3 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

